Subject: [bug#68321] Request for merging "lisp-team" branch

From: Efraim Flashner <[email-masked]>
Date: Tue, 9 Jan 2024 22:24:10 +0200

On Tue, Jan 09, 2024 at 02:10:17PM +0000, Guillaume Le Vaillant wrote:
> "Paul A. Patience" <[email-masked]> skribis:
> 
> > On Monday, January 8th, 2024 at 1:12 PM, Efraim Flashner <[email-masked]> wrote:
> >> I have [email-masked] from the lisp-team branch failing to build on
> >> powerpc64le and succeeding on aarch64-linux.
> >>
> >> riscv64-linux failed for me too:
> >
> > I don't have a ppc64le machine, and I don't know about riscv64,
> > but SBCL 2.4.0 needs a patch to build on ppc64 [1].
> >
> > [1]: https://github.com/sbcl/sbcl/commit/255f3ead060129aa097b62f10d054cdc4997a431
> 
> I adapted the patch from upstream and added it to the lisp-team branch.
> 
> I tried testing the build with "guix build -s powerpc46le-linux sbcl"
> on my x86-64 machine, but it failed indicating that the clisp used to
> boostrap sbcl isn't working properly. I don't know if the problem comes
> from qemu or if clisp is really broken on powerpc64le.
> Efraim, could you check on your powerpc64le machine?
> 
> I also tried "guix build -s riscv64-linux sbcl", but it didn't work,
> because some dependencies fail to build (like gnutls).

riscv64-linux failure looks similar at first look to the ppc64le failure

"obj/from-xc/src/code/cold-error.lisp-obj"
"obj/from-xc/src/code/early-full-eval.lisp-obj"
"obj/from-xc/src/code/debug-var-io.lisp-obj"
"obj/from-xc/src/code/early-float.lisp-obj" fatal error encountered in SBCL pid 553 tid 553:
internal error too early in init, can't recover

Error opening /dev/tty: No such device or address
Internal error #1 "An attempt was made to use an undefined FDEFINITION." at 0x4101560
    SC: 0, Offset: 28   $1=       0x4f286dff: other pointer
Welcome to LDB, a low-level debugger for the Lisp runtime environment.
ldb>
real    0m0.325s
user    0m0.066s
sys     0m0.242s
error: in phase 'build': uncaught exception:
%exception #<&invoke-error program: "sh" arguments: ("make.sh" "clisp" "--prefix=/gnu/store/wwy4kc4ary627b7igx5cxjsgkl8nq0yv-sbcl-2.4.0" "--dynamic-space-size=3072" "--with-sb-core-compression" "--with-sb-xref-for-internals" "--without-sb-simd") exit-status: 1 term-signal: #f stop-signal: #f>
phase `build' failed after 10113.1 seconds

-- 
Efraim Flashner   <[email-masked]>   רנשלפ םירפא
GPG key = A28B F40C 3E55 1372 662D  14F7 41AA E7DC CA3D 8351
Confidentiality cannot be guaranteed on emails sent or received unencrypted